
  /*
  *  The Ball Manager manges the Gameball and the Dropping Position
  */
  
  class BallManager
  {
    //Objects
    FWorld _world;
    FCircle _ball;
    
    //Variables
    PVector _dropPosition;
    int _droppings = 0;
    
    //Images
    PImage _imageDropper;
    PImage _imageBall;
    
    //Constructor
    BallManager(int x, int y, FWorld world)
    {
      //Settings
      _dropPosition = new PVector(x,y,0);
      _world = world;
      
      //Load Image
      _imageDropper = loadImage("data/images/drop.png");
      _imageBall = loadImage("data/images/ball.png");
    }
    
    //Call
    void draw()
    {
      //Draw Drop Image
      image(_imageDropper,_dropPosition.x-50,_dropPosition.y-50);
    }
    
    //Drop a Ball
    void dropBall()
    {
      //Clean Balls
      removeBall();
      
      //Get Ball
      _ball = new FCircle(30);
      _ball.setNoStroke();
      _ball.setFill(255,0,0);
      _ball.setPosition(_dropPosition.x,_dropPosition.y);
      _ball.setRestitution(0.9);
      _ball.setDamping(0);
      _ball.attachImage(_imageBall);
    
      //Add to World
      _world.add(_ball);
      _droppings++;
    }
    
    //Remove Ball
    void removeBall()
    {
      //Remove Ball from World
      _world.remove(_ball);
    } 
  }
