  
  /*
  *  Manage Higscores in XML Files
  */
  
  class HighscoreList
  {
    //Variables
    XMLElement _xml;
    String _file;
    
    //Constructor
    HighscoreList(PApplet sketch, String file)
    {
      //Set File Path
      _file = file;
  
      //Load File
      _xml = new XMLElement(sketch, _file);
    }
    
    //Add a Score
    void addScore(String username, int score)
    {
      //New Score Entry
      XMLElement entry = new XMLElement("score");
      entry.setString("username",username);
      entry.setInt("score",score);
      
      //Add to XML & Save
      _xml.addChild(entry);    
      
      //Save XML
      _xml.save(_file);
    }
    
    //Compute Top Ranking
    String computeTop(int count)
    {
      //Variables
      int[] scores = new int[100];
      String highscores = "";
      
      //Get Scores
      for(int i=0; i < _xml.getChildCount() && i < 100; i++)
      {
        scores[i] = _xml.getChild(i).getInt("score");
      }
      
      //Sort & Reverse Scores
      scores = sort(scores);
      scores = reverse(scores);
      
      //Get Highscores
      for(int i=0; i < count && i < _xml.getChildCount(); i++)
      { 
        //Loop throgh XML
        for(int ii=0; ii < _xml.getChildCount() && ii < 100; ii++)
        { 
          //Check Score
          if(scores[i] == _xml.getChild(ii).getInt("score"))
          {
            //Read Score
            highscores = highscores+_xml.getChild(ii).getString("username");
            highscores = highscores+": "+_xml.getChild(ii).getInt("score")+"\n";
          }
        }
      }
      
      //Return String
      return highscores;
    }
    
    //Clear List
    void clear()
    {
      //Delete all Childs
      while(_xml.getChildCount() > 0)
      {
        _xml.removeChild(0);
      }
      
      //Save XML
      _xml.save(_file);
    }
  }
